import math
def decoupage_tranches(nombre):
    """découpe un entier en blocs de 2 chiffres en partant de la droite"""
    chaine_nombre = str(nombre)
    liste_tranches = []
    while len(chaine_nombre) >= 2 :
        tranche = chaine_nombre[-2] + chaine_nombre[-1] # extraction de la tranche la plus à droite
        liste_tranches = [tranche] + liste_tranches # ajout de la tranche en tête de liste
        chaine_nombre = chaine_nombre[:-2] # on prend la liste tronquée de ses deux derniers éléments
    if chaine_nombre != '': # on rajoute un éventuel reste si le nombre de chiffres est impair
        liste_tranches = [chaine_nombre] + liste_tranches
    return liste_tranches


def racine_potence(nombre,nb_decimales):
    """renvoie la racine carrée d'un nombre entier, avec une précision spécifiée par nb_decimales"""
    nombre = int(str(nombre)+'00'*nb_decimales) # reconstitution du nombre en l'y adjoignant des tranches de '00' pour aller jusqu'à la précision souhaitée
    liste_tranches = decoupage_tranches(nombre)
    # gestion de la première tranche
    dividende = int(liste_tranches.pop(0)) # on enlève la première tranche de la liste
    chiffre = 0
    while chiffre**2 <= dividende : # recherche de la racine carrée de la première tranche
        chiffre = chiffre + 1
    chiffre = chiffre - 1
    racine = chiffre
    reste = dividende - chiffre**2
    # gestion des autres tranches
    while liste_tranches != []:
        dividende = int(str(reste) + liste_tranches.pop(0))
        double = 2 * racine
        chiffre = 0
        while (double*10 + chiffre)*chiffre <= dividende :
            chiffre = chiffre + 1
        chiffre = chiffre - 1
        racine = 10*racine + chiffre
        reste = dividende - (double*10 + chiffre)*chiffre
    return racine/10**(nb_decimales)



